# @verdaccio/cli

## 7.0.0-next-7.10

### Patch Changes

- @verdaccio/core@7.0.0-next-7.10
- @verdaccio/config@7.0.0-next-7.10
- @verdaccio/node-api@7.0.0-next-7.10
- @verdaccio/logger@7.0.0-next-7.10

## 7.0.0-next-7.9

### Patch Changes

- @verdaccio/node-api@7.0.0-next-7.9
- @verdaccio/core@7.0.0-next-7.9
- @verdaccio/config@7.0.0-next-7.9
- @verdaccio/logger@7.0.0-next-7.9

## 7.0.0-next-7.8

### Patch Changes

- @verdaccio/node-api@7.0.0-next-7.8
- @verdaccio/core@7.0.0-next-7.8
- @verdaccio/config@7.0.0-next-7.8
- @verdaccio/logger@7.0.0-next-7.8

## 7.0.0-next-7.7

### Patch Changes

- @verdaccio/core@7.0.0-next-7.7
- @verdaccio/config@7.0.0-next-7.7
- @verdaccio/node-api@7.0.0-next-7.7
- @verdaccio/logger@7.0.0-next-7.7

## 7.0.0-next.6

### Patch Changes

- Updated dependencies [4d96324]
  - @verdaccio/config@7.0.0-next.6
  - @verdaccio/node-api@7.0.0-next.6
  - @verdaccio/core@7.0.0-next.6
  - @verdaccio/logger@7.0.0-next.6

## 7.0.0-next.5

### Patch Changes

- Updated dependencies [f047cc8]
  - @verdaccio/core@7.0.0-next.5
  - @verdaccio/config@7.0.0-next.5
  - @verdaccio/node-api@7.0.0-next.5
  - @verdaccio/logger@7.0.0-next.5

## 7.0.0-next.4

### Patch Changes

- @verdaccio/node-api@7.0.0-next.4
- @verdaccio/core@7.0.0-next.4
- @verdaccio/config@7.0.0-next.4
- @verdaccio/logger@7.0.0-next.4

## 7.0.0-next.3

### Major Changes

- e7ebccb61: update major dependencies, remove old nodejs support

### Patch Changes

- Updated dependencies [daceb6d87]
- Updated dependencies [e7ebccb61]
  - @verdaccio/config@7.0.0-next.3
  - @verdaccio/core@7.0.0-next.3
  - @verdaccio/logger@7.0.0-next.3
  - @verdaccio/node-api@7.0.0-next.3

## 7.0.0-next.2

### Patch Changes

- @verdaccio/core@7.0.0-next.2
- @verdaccio/config@7.0.0-next.2
- @verdaccio/node-api@7.0.0-next.2
- @verdaccio/logger@7.0.0-next.2

## 7.0.0-next.1

### Patch Changes

- @verdaccio/core@7.0.0-next.1
- @verdaccio/config@7.0.0-next.1
- @verdaccio/node-api@7.0.0-next.1
- @verdaccio/logger@7.0.0-next.1

## 7.0.0-next.0

### Major Changes

- feat!: bump to v7

### Patch Changes

- Updated dependencies
  - @verdaccio/config@7.0.0-next.0
  - @verdaccio/core@7.0.0-next.0
  - @verdaccio/logger@7.0.0-next.0
  - @verdaccio/node-api@7.0.0-next.0

## 6.0.0

### Major Changes

- 292c0a37f: feat!: replace deprecated request dependency by got

  This is a big refactoring of the core, fetching dependencies, improve code, more tests and better stability. This is essential for the next release, will take some time but would allow modularize more the core.

  ## Notes

  - Remove deprecated `request` by other `got`, retry improved, custom Agent ( got does not include it built-in)
  - Remove `async` dependency from storage (used by core) it was linked with proxy somehow safe to remove now
  - Refactor with promises instead callback wherever is possible
  - ~Document the API~
  - Improve testing, integration tests
  - Bugfix
  - Clean up old validations
  - Improve performance

  ## 💥 Breaking changes

  - Plugin API methods were callbacks based are returning promises, this will break current storage plugins, check documentation for upgrade.
  - Write Tarball, Read Tarball methods parameters change, a new set of options like `AbortController` signals are being provided to the `addAbortSignal` can be internally used with Streams when a request is aborted. eg: `addAbortSignal(signal, fs.createReadStream(pathName));`
  - `@verdaccio/streams` stream abort support is legacy is being deprecated removed
  - Remove AWS and Google Cloud packages for future refactoring [#2574](https://github.com/verdaccio/verdaccio/pull/2574).

- a3a209b5e: feat: migrate to pino.js 8
- 459b6fa72: refactor: search v1 endpoint and local-database

  - refactor search `api v1` endpoint, improve performance
  - remove usage of `async` dependency https://github.com/verdaccio/verdaccio/issues/1225
  - refactor method storage class
  - create new module `core` to reduce the ammount of modules with utilities
  - use `undici` instead `node-fetch`
  - use `fastify` instead `express` for functional test

  ### Breaking changes

  - plugin storage API changes
  - remove old search endpoint (return 404)
  - filter local private packages at plugin level

  The storage api changes for methods `get`, `add`, `remove` as promise base. The `search` methods also changes and recieves a `query` object that contains all query params from the client.

  ```ts
  export interface IPluginStorage<T> extends IPlugin {
    add(name: string): Promise<void>;
    remove(name: string): Promise<void>;
    get(): Promise<any>;
    init(): Promise<void>;
    getSecret(): Promise<string>;
    setSecret(secret: string): Promise<any>;
    getPackageStorage(packageInfo: string): IPackageStorage;
    search(query: searchUtils.SearchQuery): Promise<searchUtils.SearchItem[]>;
    saveToken(token: Token): Promise<any>;
    deleteToken(user: string, tokenKey: string): Promise<any>;
    readTokens(filter: TokenFilter): Promise<Token[]>;
  }
  ```

- 794af76c5: Remove Node 12 support

  - We need move to the new `undici` and does not support Node.js 12

- 10aeb4f13: feat!: experiments config renamed to flags

  - The `experiments` configuration is renamed to `flags`. The functionality is exactly the same.

  ```js
  flags: token: false;
  search: false;
  ```

  - The `self_path` property from the config file is being removed in favor of `config_file` full path.
  - Refactor `config` module, better types and utilities

- e367c3f1e: - Replace signature handler for legacy tokens by removing deprecated crypto.createDecipher by createCipheriv

  - Introduce environment variables for legacy tokens

  ### Code Improvements

  - Add debug library for improve developer experience

  ### Breaking change

  - The new signature invalidates all previous tokens generated by Verdaccio 4 or previous versions.
  - The secret key must have 32 characters long.

  ### New environment variables

  - `VERDACCIO_LEGACY_ALGORITHM`: Allows to define the specific algorithm for the token signature which by default is `aes-256-ctr`
  - `VERDACCIO_LEGACY_ENCRYPTION_KEY`: By default, the token stores in the database, but using this variable allows to get it from memory

- 2e3b9552c: feat: node 14 as minimum for running cli
- 5becf3f25: feat: use clipanion over commander
- 82cb0f2bf: feat!: config.logs throw an error, logging config not longer accept array or logs property

  ### 💥 Breaking change

  This is valid

  ```yaml
  log: { type: stdout, format: pretty, level: http }
  ```

  This is invalid

  ```yaml
  logs: { type: stdout, format: pretty, level: http }
  ```

  or

  ```yaml
  logs:
    - [{ type: stdout, format: pretty, level: http }]
  ```

- 8f43bf17d: feat: node api new structure based on promise

  ```js
  import { runServer } from "@verdaccio/node-api";
  // or
  import { runServer } from "verdaccio";

  const app = await runServer(); // default configuration
  const app = await runServer("./config/config.yaml");
  const app = await runServer({ configuration });
  app.listen(4000, (event) => {
    // do something
  });
  ```

  ### Breaking Change

  If you are using the node-api, the new structure is Promise based and less arguments.

### Minor Changes

- 974cd8c19: fix: startup messages improved and logs support on types
- 631abe1ac: feat: refactor logger
- 00d1d2a17: chore: env variable for launch fastify

  - Update fastify to major release `v4.3.0`
  - Update CLI launcher

  via CLI

  ```
  VERDACCIO_SERVER=fastify verdaccio
  ```

  with docker

  ```
  docker run -it --rm --name verdaccio \
    -e "VERDACCIO_SERVER=8080" -p 8080:8080 \
    -e "VERDACCIO_SERVER=fastify" \
    verdaccio/verdaccio
  ```

- 55ee3fdd9: [Fastify] Add ping endpoint
- b61f762d6: feat: add server rate limit protection to all request

  To modify custom values, use the server settings property.

  ```markdown
  server:

  ## https://www.npmjs.com/package/express-rate-limit#configuration-options

  rateLimit:
  windowMs: 1000
  max: 10000
  ```

  The values are intended to be high, if you want to improve security of your server consider
  using different values.

- 154b2ecd3: refactor: remove @verdaccio/commons-api in favor @verdaccio/core and remove duplications
- aa763baec: feat: add typescript project references settings

  Reading https://ebaytech.berlin/optimizing-multi-package-apps-with-typescript-project-references-d5c57a3b4440 I realized I can use project references to solve the issue to pre-compile modules on develop mode.

  It allows to navigate (IDE) trough the packages without need compile the packages.

  Add two `tsconfig`, one using the previous existing configuration that is able to produce declaration files (`tsconfig.build`) and a new one `tsconfig` which is enables [_projects references_](https://www.typescriptlang.org/docs/handbook/project-references.html).

- d5eacc218: feat: improve cli loggin on start up
- 6c1eb021b: feat: use warning codes for deprecation warnings

### Patch Changes

- d78c8b515: chore: improve error logger message
- 351aeeaa8: fix(deps): @verdaccio/utils should be a prod dep of local-storage
- 19d272d10: fix: restore logger on init

  Enable logger after parse configuration and log the very first step on startup phase.

  ```bash
   warn --- experiments are enabled, it is recommended do not use experiments in production comment out this section to disable it
   info --- support for experiment [token]  is disabled
   info --- support for experiment [search]  is disabled
  (node:50831) Warning: config.logs is deprecated, rename configuration to "config.log"
  (Use `node --trace-warnings ...` to show where the warning was created)
   info --- http address http://localhost:4873/
   info --- version: 6.0.0-6-next.11
   info --- server started
  ```

- a610ef26b: chore: add release step to private regisry on merge changeset pr
- 020ede43f: fix: version with breakline
- 34f0f1101: Enable prerelease mode with **changesets**
- 68ea21214: ESLint Warnings Fixed

  Related to issue #1461

  - max-len: most of the sensible max-len errors are fixed
  - no-unused-vars: most of these types of errors are fixed by deleting not needed declarations
  - @typescript-eslint/no-unused-vars: same as above

- b849128de: fix: handle upload scoped tarball
- Updated dependencies [292c0a37f]
- Updated dependencies [974cd8c19]
- Updated dependencies [ef88da3b4]
- Updated dependencies [43f32687c]
- Updated dependencies [679c19c1b]
- Updated dependencies [a3a209b5e]
- Updated dependencies [459b6fa72]
- Updated dependencies [9fc2e7961]
- Updated dependencies [24b9be020]
- Updated dependencies [794af76c5]
- Updated dependencies [e75c0a3b9]
- Updated dependencies [351aeeaa8]
- Updated dependencies [10aeb4f13]
- Updated dependencies [631abe1ac]
- Updated dependencies [9718e0330]
- Updated dependencies [1b217fd34]
- Updated dependencies [e367c3f1e]
- Updated dependencies [a1da11308]
- Updated dependencies [d167f92e1]
- Updated dependencies [00d1d2a17]
- Updated dependencies [19d272d10]
- Updated dependencies [1810ed0d8]
- Updated dependencies [a610ef26b]
- Updated dependencies [ddb6a2239]
- Updated dependencies [b61f762d6]
- Updated dependencies [d43894e8f]
- Updated dependencies [154b2ecd3]
- Updated dependencies [aa763baec]
- Updated dependencies [d5eacc218]
- Updated dependencies [378e907d5]
- Updated dependencies [16e38df8a]
- Updated dependencies [34f0f1101]
- Updated dependencies [df0da3d69]
- Updated dependencies [82cb0f2bf]
- Updated dependencies [dc571aabd]
- Updated dependencies [b78f35257]
- Updated dependencies [f859d2b1a]
- Updated dependencies [2c594910d]
- Updated dependencies [6c1eb021b]
- Updated dependencies [62c24b632]
- Updated dependencies [0a6412ca9]
- Updated dependencies [d08fe29d9]
- Updated dependencies [5167bb528]
- Updated dependencies [65f88b826]
- Updated dependencies [b3e8438f6]
- Updated dependencies [c9d1af0e5]
- Updated dependencies [730b5d8cc]
- Updated dependencies [4b29d715b]
- Updated dependencies [68ea21214]
- Updated dependencies [8f43bf17d]
- Updated dependencies [45c03819e]
- Updated dependencies [b849128de]
  - @verdaccio/config@6.0.0
  - @verdaccio/core@6.0.0
  - @verdaccio/logger@6.0.0
  - @verdaccio/node-api@6.0.0

## 6.0.0-6-next.76

### Patch Changes

- @verdaccio/node-api@6.0.0-6-next.76
- @verdaccio/core@6.0.0-6-next.76
- @verdaccio/config@6.0.0-6-next.76
- @verdaccio/logger@6.0.0-6-next.44

## 6.0.0-6-next.75

### Patch Changes

- Updated dependencies [0a6412ca9]
  - @verdaccio/core@6.0.0-6-next.75
  - @verdaccio/config@6.0.0-6-next.75
  - @verdaccio/node-api@6.0.0-6-next.75
  - @verdaccio/logger@6.0.0-6-next.43

## 6.0.0-6-next.74

### Patch Changes

- @verdaccio/node-api@6.0.0-6-next.74
- @verdaccio/core@6.0.0-6-next.74
- @verdaccio/config@6.0.0-6-next.74
- @verdaccio/logger@6.0.0-6-next.42

## 6.0.0-6-next.73

### Patch Changes

- Updated dependencies [f859d2b1a]
  - @verdaccio/core@6.0.0-6-next.73
  - @verdaccio/config@6.0.0-6-next.73
  - @verdaccio/node-api@6.0.0-6-next.73
  - @verdaccio/logger@6.0.0-6-next.41

## 6.0.0-6-next.72

### Patch Changes

- @verdaccio/node-api@6.0.0-6-next.72
- @verdaccio/core@6.0.0-6-next.72
- @verdaccio/config@6.0.0-6-next.72
- @verdaccio/logger@6.0.0-6-next.40

## 6.0.0-6-next.71

### Patch Changes

- Updated dependencies [679c19c1b]
  - @verdaccio/config@6.0.0-6-next.71
  - @verdaccio/node-api@6.0.0-6-next.71
  - @verdaccio/logger@6.0.0-6-next.39
  - @verdaccio/core@6.0.0-6-next.71

## 6.0.0-6-next.70

### Patch Changes

- @verdaccio/logger@6.0.0-6-next.38
- @verdaccio/node-api@6.0.0-6-next.70
- @verdaccio/core@6.0.0-6-next.70
- @verdaccio/config@6.0.0-6-next.70

## 6.0.0-6-next.69

### Patch Changes

- Updated dependencies [c9d1af0e]
  - @verdaccio/core@6.0.0-6-next.69
  - @verdaccio/config@6.0.0-6-next.69
  - @verdaccio/node-api@6.0.0-6-next.69
  - @verdaccio/logger@6.0.0-6-next.37

## 6.0.0-6-next.68

### Patch Changes

- @verdaccio/node-api@6.0.0-6-next.68
- @verdaccio/core@6.0.0-6-next.68
- @verdaccio/config@6.0.0-6-next.68
- @verdaccio/logger@6.0.0-6-next.36

## 6.0.0-6-next.67

### Patch Changes

- Updated dependencies [16e38df8]
  - @verdaccio/config@6.0.0-6-next.67
  - @verdaccio/core@6.0.0-6-next.67
  - @verdaccio/node-api@6.0.0-6-next.67
  - @verdaccio/logger@6.0.0-6-next.35

## 6.0.0-6-next.66

### Patch Changes

- @verdaccio/core@6.0.0-6-next.66
- @verdaccio/logger@6.0.0-6-next.34
- @verdaccio/node-api@6.0.0-6-next.66
- @verdaccio/config@6.0.0-6-next.66

## 6.0.0-6-next.65

### Patch Changes

- Updated dependencies [a1da1130]
  - @verdaccio/core@6.0.0-6-next.65
  - @verdaccio/config@6.0.0-6-next.65
  - @verdaccio/node-api@6.0.0-6-next.65
  - @verdaccio/logger@6.0.0-6-next.33

## 6.0.0-6-next.64

### Minor Changes

- 974cd8c1: fix: startup messages improved and logs support on types

### Patch Changes

- Updated dependencies [974cd8c1]
  - @verdaccio/core@6.0.0-6-next.64
  - @verdaccio/config@6.0.0-6-next.64
  - @verdaccio/node-api@6.0.0-6-next.64
  - @verdaccio/logger@6.0.0-6-next.32

## 6.0.0-6-next.63

### Patch Changes

- Updated dependencies [ddb6a223]
- Updated dependencies [dc571aab]
  - @verdaccio/config@6.0.0-6-next.63
  - @verdaccio/core@6.0.0-6-next.63
  - @verdaccio/node-api@6.0.0-6-next.63
  - @verdaccio/logger@6.0.0-6-next.31

## 6.0.0-6-next.62

### Patch Changes

- Updated dependencies [378e907d]
  - @verdaccio/core@6.0.0-6-next.62
  - @verdaccio/logger@6.0.0-6-next.30
  - @verdaccio/node-api@6.0.0-6-next.62
  - @verdaccio/config@6.0.0-6-next.62

## 6.0.0-6-next.61

### Patch Changes

- Updated dependencies [d167f92e]
  - @verdaccio/config@6.0.0-6-next.61
  - @verdaccio/node-api@6.0.0-6-next.61
  - @verdaccio/core@6.0.0-6-next.61
  - @verdaccio/logger@6.0.0-6-next.29

## 6.0.0-6-next.60

### Patch Changes

- Updated dependencies [45c03819]
  - @verdaccio/config@6.0.0-6-next.60
  - @verdaccio/node-api@6.0.0-6-next.60
  - @verdaccio/core@6.0.0-6-next.60
  - @verdaccio/logger@6.0.0-6-next.28

## 6.0.0-6-next.59

### Patch Changes

- Updated dependencies [65f88b82]
  - @verdaccio/logger@6.0.0-6-next.27
  - @verdaccio/node-api@6.0.0-6-next.59
  - @verdaccio/core@6.0.0-6-next.59
  - @verdaccio/config@6.0.0-6-next.59

## 6.0.0-6-next.58

### Patch Changes

- @verdaccio/node-api@6.0.0-6-next.58
- @verdaccio/core@6.0.0-6-next.58
- @verdaccio/config@6.0.0-6-next.58
- @verdaccio/logger@6.0.0-6-next.26

## 6.0.0-6-next.57

### Patch Changes

- @verdaccio/node-api@6.0.0-6-next.57
- @verdaccio/core@6.0.0-6-next.57
- @verdaccio/config@6.0.0-6-next.57
- @verdaccio/logger@6.0.0-6-next.25

## 6.0.0-6-next.56

### Patch Changes

- @verdaccio/config@6.0.0-6-next.56
- @verdaccio/node-api@6.0.0-6-next.56
- @verdaccio/core@6.0.0-6-next.56
- @verdaccio/logger@6.0.0-6-next.24

## 6.0.0-6-next.55

### Patch Changes

- Updated dependencies [9718e033]
  - @verdaccio/config@6.0.0-6-next.55
  - @verdaccio/core@6.0.0-6-next.55
  - @verdaccio/node-api@6.0.0-6-next.55
  - @verdaccio/logger@6.0.0-6-next.23

## 6.0.0-6-next.54

### Patch Changes

- Updated dependencies [ef88da3b]
  - @verdaccio/config@6.0.0-6-next.54
  - @verdaccio/core@6.0.0-6-next.54
  - @verdaccio/logger@6.0.0-6-next.22
  - @verdaccio/node-api@6.0.0-6-next.54

## 6.0.0-6-next.53

### Patch Changes

- @verdaccio/core@6.0.0-6-next.53
- @verdaccio/logger@6.0.0-6-next.21
- @verdaccio/node-api@6.0.0-6-next.53
- @verdaccio/config@6.0.0-6-next.53

## 6.0.0-6-next.52

### Patch Changes

- @verdaccio/core@6.0.0-6-next.52
- @verdaccio/config@6.0.0-6-next.52
- @verdaccio/node-api@6.0.0-6-next.52
- @verdaccio/logger@6.0.0-6-next.20

## 6.0.0-6-next.51

### Patch Changes

- Updated dependencies [4b29d715]
  - @verdaccio/config@6.0.0-6-next.51
  - @verdaccio/core@6.0.0-6-next.51
  - @verdaccio/node-api@6.0.0-6-next.51
  - @verdaccio/logger@6.0.0-6-next.19

## 6.0.0-6-next.50

### Patch Changes

- @verdaccio/node-api@6.0.0-6-next.50
- @verdaccio/core@6.0.0-6-next.50
- @verdaccio/config@6.0.0-6-next.50
- @verdaccio/logger@6.0.0-6-next.18

## 6.0.0-6-next.49

### Patch Changes

- @verdaccio/node-api@6.0.0-6-next.49
- @verdaccio/core@6.0.0-6-next.49
- @verdaccio/config@6.0.0-6-next.49
- @verdaccio/logger@6.0.0-6-next.17

## 6.0.0-6-next.48

### Patch Changes

- Updated dependencies [43f32687]
- Updated dependencies [9fc2e796]
- Updated dependencies [62c24b63]
  - @verdaccio/core@6.0.0-6-next.48
  - @verdaccio/config@6.0.0-6-next.48
  - @verdaccio/node-api@6.0.0-6-next.48
  - @verdaccio/logger@6.0.0-6-next.16

## 6.0.0-6-next.47

### Patch Changes

- 020ede43: fix: version with breakline
  - @verdaccio/core@6.0.0-6-next.47
  - @verdaccio/config@6.0.0-6-next.47
  - @verdaccio/node-api@6.0.0-6-next.47
  - @verdaccio/logger@6.0.0-6-next.15

## 6.0.0-6-next.38

### Patch Changes

- b849128d: fix: handle upload scoped tarball
- Updated dependencies [b849128d]
  - @verdaccio/core@6.0.0-6-next.8
  - @verdaccio/config@6.0.0-6-next.17
  - @verdaccio/logger@6.0.0-6-next.14
  - @verdaccio/node-api@6.0.0-6-next.36

## 6.0.0-6-next.37

### Patch Changes

- 351aeeaa: fix(deps): @verdaccio/utils should be a prod dep of local-storage
- Updated dependencies [351aeeaa]
  - @verdaccio/core@6.0.0-6-next.7
  - @verdaccio/logger@6.0.0-6-next.13
  - @verdaccio/node-api@6.0.0-6-next.35
  - @verdaccio/config@6.0.0-6-next.16

## 6.0.0-6-next.36

### Patch Changes

- @verdaccio/core@6.0.0-6-next.6
- @verdaccio/logger@6.0.0-6-next.12
- @verdaccio/node-api@6.0.0-6-next.34

## 6.0.0-6-next.35

### Major Changes

- 292c0a37: feat!: replace deprecated request dependency by got

  This is a big refactoring of the core, fetching dependencies, improve code, more tests and better stability. This is essential for the next release, will take some time but would allow modularize more the core.

  ## Notes

  - Remove deprecated `request` by other `got`, retry improved, custom Agent ( got does not include it built-in)
  - Remove `async` dependency from storage (used by core) it was linked with proxy somehow safe to remove now
  - Refactor with promises instead callback wherever is possible
  - ~Document the API~
  - Improve testing, integration tests
  - Bugfix
  - Clean up old validations
  - Improve performance

  ## 💥 Breaking changes

  - Plugin API methods were callbacks based are returning promises, this will break current storage plugins, check documentation for upgrade.
  - Write Tarball, Read Tarball methods parameters change, a new set of options like `AbortController` signals are being provided to the `addAbortSignal` can be internally used with Streams when a request is aborted. eg: `addAbortSignal(signal, fs.createReadStream(pathName));`
  - `@verdaccio/streams` stream abort support is legacy is being deprecated removed
  - Remove AWS and Google Cloud packages for future refactoring [#2574](https://github.com/verdaccio/verdaccio/pull/2574).

- a3a209b5: feat: migrate to pino.js 8

### Minor Changes

- 00d1d2a1: chore: env variable for launch fastify

  - Update fastify to major release `v4.3.0`
  - Update CLI launcher

  via CLI

  ```
  VERDACCIO_SERVER=fastify verdaccio
  ```

  with docker

  ```
  docker run -it --rm --name verdaccio \
    -e "VERDACCIO_SERVER=8080" -p 8080:8080 \
    -e "VERDACCIO_SERVER=fastify" \
    verdaccio/verdaccio
  ```

### Patch Changes

- Updated dependencies [292c0a37]
- Updated dependencies [a3a209b5]
- Updated dependencies [00d1d2a1]
  - @verdaccio/config@6.0.0-6-next.15
  - @verdaccio/core@6.0.0-6-next.6
  - @verdaccio/logger@6.0.0-6-next.12
  - @verdaccio/node-api@6.0.0-6-next.33

## 6.0.0-6-next.34

### Patch Changes

- @verdaccio/node-api@6.0.0-6-next.32

## 6.0.0-6-next.33

### Patch Changes

- Updated dependencies [d43894e8]
- Updated dependencies [d08fe29d]
  - @verdaccio/config@6.0.0-6-next.14
  - @verdaccio/server-fastify@6.0.0-6-next.23
  - @verdaccio/node-api@6.0.0-6-next.31
  - @verdaccio/core@6.0.0-6-next.5
  - @verdaccio/logger@6.0.0-6-next.11

## 6.0.0-6-next.32

### Patch Changes

- d78c8b51: chore: improve error logger message

## 6.0.0-6-next.31

### Major Changes

- 82cb0f2b: feat!: config.logs throw an error, logging config not longer accept array or logs property

  ### 💥 Breaking change

  This is valid

  ```yaml
  log: { type: stdout, format: pretty, level: http }
  ```

  This is invalid

  ```yaml
  logs: { type: stdout, format: pretty, level: http }
  ```

  or

  ```yaml
  logs:
    - [{ type: stdout, format: pretty, level: http }]
  ```

### Patch Changes

- Updated dependencies [82cb0f2b]
- Updated dependencies [5167bb52]
  - @verdaccio/config@6.0.0-6-next.13
  - @verdaccio/core@6.0.0-6-next.5
  - @verdaccio/logger@6.0.0-6-next.11
  - @verdaccio/node-api@6.0.0-6-next.30
  - @verdaccio/server-fastify@6.0.0-6-next.22

## 6.0.0-6-next.30

### Patch Changes

- @verdaccio/server-fastify@6.0.0-6-next.21
- @verdaccio/node-api@6.0.0-6-next.29

## 6.0.0-6-next.29

### Patch Changes

- @verdaccio/server-fastify@6.0.0-6-next.20
- @verdaccio/node-api@6.0.0-6-next.28

## 6.0.0-6-next.28

### Patch Changes

- Updated dependencies [b78f3525]
  - @verdaccio/logger@6.0.0-6-next.10
  - @verdaccio/server-fastify@6.0.0-6-next.19
  - @verdaccio/node-api@6.0.0-6-next.27

## 6.0.0-6-next.27

### Patch Changes

- Updated dependencies [730b5d8c]
  - @verdaccio/logger@6.0.0-6-next.9
  - @verdaccio/node-api@6.0.0-6-next.26
  - @verdaccio/server-fastify@6.0.0-6-next.18

## 6.0.0-6-next.26

### Patch Changes

- Updated dependencies [a828271d]
- Updated dependencies [24b9be02]
- Updated dependencies [e75c0a3b]
  - @verdaccio/server-fastify@6.0.0-6-next.17
  - @verdaccio/core@6.0.0-6-next.4
  - @verdaccio/logger@6.0.0-6-next.8
  - @verdaccio/node-api@6.0.0-6-next.25
  - @verdaccio/config@6.0.0-6-next.12

## 6.0.0-6-next.25

### Patch Changes

- Updated dependencies [f86c31ed]
- Updated dependencies [20c9e43e]
  - @verdaccio/server-fastify@6.0.0-6-next.16
  - @verdaccio/config@6.0.0-6-next.11
  - @verdaccio/node-api@6.0.0-6-next.24

## 6.0.0-6-next.24

### Minor Changes

- 6c1eb021: feat: use warning codes for deprecation warnings

### Patch Changes

- Updated dependencies [6c1eb021]
  - @verdaccio/core@6.0.0-6-next.3
  - @verdaccio/logger@6.0.0-6-next.7
  - @verdaccio/node-api@6.0.0-6-next.23
  - @verdaccio/config@6.0.0-6-next.10
  - @verdaccio/server-fastify@6.0.0-6-next.15

## 6.0.0-6-next.23

### Major Changes

- 794af76c: Remove Node 12 support

  - We need move to the new `undici` and does not support Node.js 12

### Minor Changes

- 154b2ecd: refactor: remove @verdaccio/commons-api in favor @verdaccio/core and remove duplications

### Patch Changes

- Updated dependencies [794af76c]
- Updated dependencies [b702ea36]
- Updated dependencies [154b2ecd]
  - @verdaccio/config@6.0.0-6-next.9
  - @verdaccio/server-fastify@6.0.0-6-next.14
  - @verdaccio/logger@6.0.0-6-next.6
  - @verdaccio/node-api@6.0.0-6-next.22

## 6.0.0-6-next.22

### Patch Changes

- Updated dependencies [2c594910]
  - @verdaccio/logger@6.0.0-6-next.5
  - @verdaccio/server-fastify@6.0.0-6-next.13
  - @verdaccio/node-api@6.0.0-6-next.21

## 6.0.0-6-next.21

### Major Changes

- 459b6fa7: refactor: search v1 endpoint and local-database

  - refactor search `api v1` endpoint, improve performance
  - remove usage of `async` dependency https://github.com/verdaccio/verdaccio/issues/1225
  - refactor method storage class
  - create new module `core` to reduce the ammount of modules with utilities
  - use `undici` instead `node-fetch`
  - use `fastify` instead `express` for functional test

  ### Breaking changes

  - plugin storage API changes
  - remove old search endpoint (return 404)
  - filter local private packages at plugin level

  The storage api changes for methods `get`, `add`, `remove` as promise base. The `search` methods also changes and recieves a `query` object that contains all query params from the client.

  ```ts
  export interface IPluginStorage<T> extends IPlugin {
    add(name: string): Promise<void>;
    remove(name: string): Promise<void>;
    get(): Promise<any>;
    init(): Promise<void>;
    getSecret(): Promise<string>;
    setSecret(secret: string): Promise<any>;
    getPackageStorage(packageInfo: string): IPackageStorage;
    search(query: searchUtils.SearchQuery): Promise<searchUtils.SearchItem[]>;
    saveToken(token: Token): Promise<any>;
    deleteToken(user: string, tokenKey: string): Promise<any>;
    readTokens(filter: TokenFilter): Promise<Token[]>;
  }
  ```

### Patch Changes

- Updated dependencies [459b6fa7]
  - @verdaccio/config@6.0.0-6-next.8
  - @verdaccio/server-fastify@6.0.0-6-next.12
  - @verdaccio/node-api@6.0.0-6-next.20
  - @verdaccio/logger@6.0.0-6-next.4

## 6.0.0-6-next.20

### Patch Changes

- Updated dependencies [df0da3d6]
  - @verdaccio/server-fastify@6.0.0-6-next.11
  - @verdaccio/node-api@6.0.0-6-next.19

## 6.0.0-6-next.19

### Major Changes

- 2e3b9552: feat: node 14 as minimum for running cli

## 6.0.0-6-next.18

### Patch Changes

- @verdaccio/node-api@6.0.0-6-next.18

## 6.0.0-6-next.17

### Minor Changes

- 55ee3fdd: [Fastify] Add ping endpoint

### Patch Changes

- Updated dependencies [55ee3fdd]
  - @verdaccio/server-fastify@6.0.0-6-next.10
  - @verdaccio/config@6.0.0-6-next.7
  - @verdaccio/node-api@6.0.0-6-next.17

## 6.0.0-6-next.16

### Patch Changes

- @verdaccio/node-api@6.0.0-6-next.16

## 6.0.0-6-next.15

### Patch Changes

- @verdaccio/server-fastify@6.0.0-6-next.9
- @verdaccio/logger@6.0.0-6-next.4
- @verdaccio/node-api@6.0.0-6-next.15

## 6.0.0-6-next.14

### Patch Changes

- @verdaccio/server-fastify@6.0.0-6-next.9
- @verdaccio/logger@6.0.0-6-next.4
- @verdaccio/node-api@6.0.0-6-next.14

## 6.0.0-6-next.13

### Patch Changes

- Updated dependencies [1b217fd3]
  - @verdaccio/config@6.0.0-6-next.6
  - @verdaccio/node-api@6.0.0-6-next.13

## 6.0.0-6-next.12

### Patch Changes

- 19d272d1: fix: restore logger on init

  Enable logger after parse configuration and log the very first step on startup phase.

  ```bash
   warn --- experiments are enabled, it is recommended do not use experiments in production comment out this section to disable it
   info --- support for experiment [token]  is disabled
   info --- support for experiment [search]  is disabled
  (node:50831) Warning: config.logs is deprecated, rename configuration to "config.log"
  (Use `node --trace-warnings ...` to show where the warning was created)
   info --- http address http://localhost:4873/
   info --- version: 6.0.0-6-next.11
   info --- server started
  ```

- Updated dependencies [19d272d1]
  - @verdaccio/node-api@6.0.0-6-next.12
  - @verdaccio/server-fastify@6.0.0-6-next.9
  - @verdaccio/logger@6.0.0-6-next.4

## 6.0.0-6-next.11

### Patch Changes

- Updated dependencies [1810ed0d]
  - @verdaccio/config@6.0.0-6-next.5
  - @verdaccio/node-api@6.0.0-6-next.11

## 6.0.0-6-next.10

### Major Changes

- 5c5057fc: feat: node api new structure based on promise

  ```js
  import { runServer } from "@verdaccio/node-api";
  // or
  import { runServer } from "verdaccio";

  const app = await runServer(); // default configuration
  const app = await runServer("./config/config.yaml");
  const app = await runServer({ configuration });
  app.listen(4000, (event) => {
    // do something
  });
  ```

  ### Breaking Change

  If you are using the node-api, the new structure is Promise based and less arguments.

### Patch Changes

- Updated dependencies [5c5057fc]
  - @verdaccio/config@6.0.0-6-next.4
  - @verdaccio/node-api@6.0.0-6-next.10

## 6.0.0-6-next.9

### Major Changes

- 08aade9a: feat: use clipanion over commander

### Patch Changes

- @verdaccio/node-api@6.0.0-6-next.9

## 5.0.0-alpha.8

### Patch Changes

- @verdaccio/node-api@5.0.0-alpha.8

## 5.0.0-alpha.7

### Minor Changes

- 64737a37: feat: improve cli loggin on start up

### Patch Changes

- Updated dependencies [64737a37]
  - @verdaccio/node-api@5.0.0-alpha.7

## 5.0.0-alpha.6

### Patch Changes

- @verdaccio/node-api@5.0.0-alpha.6

## 5.0.0-alpha.5

### Patch Changes

- @verdaccio/node-api@5.0.0-alpha.5

## 5.0.0-alpha.4

### Patch Changes

- fecbb9be: chore: add release step to private regisry on merge changeset pr
- Updated dependencies [fecbb9be]
  - @verdaccio/config@5.0.0-alpha.3
  - @verdaccio/logger@5.0.0-alpha.3
  - @verdaccio/node-api@5.0.0-alpha.4

## 5.0.0-alpha.3

### Minor Changes

- 54c58d1e: feat: add server rate limit protection to all request

  To modify custom values, use the server settings property.

  ```markdown
  server:

  ## https://www.npmjs.com/package/express-rate-limit#configuration-options

  rateLimit:
  windowMs: 1000
  max: 10000
  ```

  The values are intended to be high, if you want to improve security of your server consider
  using different values.

### Patch Changes

- Updated dependencies [54c58d1e]
  - @verdaccio/config@5.0.0-alpha.2
  - @verdaccio/logger@5.0.0-alpha.2
  - @verdaccio/node-api@5.0.0-alpha.3

## 5.0.0-alpha.2

### Patch Changes

- @verdaccio/node-api@5.0.0-alpha.2

## 5.0.0-alpha.1

### Major Changes

- d87fa026: feat!: experiments config renamed to flags

  - The `experiments` configuration is renamed to `flags`. The functionality is exactly the same.

  ```js
  flags: token: false;
  search: false;
  ```

  - The `self_path` property from the config file is being removed in favor of `config_file` full path.
  - Refactor `config` module, better types and utilities

- da1ee9c8: - Replace signature handler for legacy tokens by removing deprecated crypto.createDecipher by createCipheriv

  - Introduce environment variables for legacy tokens

  ### Code Improvements

  - Add debug library for improve developer experience

  ### Breaking change

  - The new signature invalidates all previous tokens generated by Verdaccio 4 or previous versions.
  - The secret key must have 32 characters long.

  ### New environment variables

  - `VERDACCIO_LEGACY_ALGORITHM`: Allows to define the specific algorithm for the token signature which by default is `aes-256-ctr`
  - `VERDACCIO_LEGACY_ENCRYPTION_KEY`: By default, the token stores in the database, but using this variable allows to get it from memory

### Minor Changes

- 26b494cb: feat: add typescript project references settings

  Reading https://ebaytech.berlin/optimizing-multi-package-apps-with-typescript-project-references-d5c57a3b4440 I realized I can use project references to solve the issue to pre-compile modules on develop mode.

  It allows to navigate (IDE) trough the packages without need compile the packages.

  Add two `tsconfig`, one using the previous existing configuration that is able to produce declaration files (`tsconfig.build`) and a new one `tsconfig` which is enables [_projects references_](https://www.typescriptlang.org/docs/handbook/project-references.html).

### Patch Changes

- b57b4338: Enable prerelease mode with **changesets**
- 31af0164: ESLint Warnings Fixed

  Related to issue #1461

  - max-len: most of the sensible max-len errors are fixed
  - no-unused-vars: most of these types of errors are fixed by deleting not needed declarations
  - @typescript-eslint/no-unused-vars: same as above

- Updated dependencies [d87fa026]
- Updated dependencies [da1ee9c8]
- Updated dependencies [26b494cb]
- Updated dependencies [b57b4338]
- Updated dependencies [add778d5]
- Updated dependencies [31af0164]
  - @verdaccio/config@5.0.0-alpha.1
  - @verdaccio/logger@5.0.0-alpha.1
  - @verdaccio/node-api@5.0.0-alpha.1

## 5.0.0-alpha.1

### Major Changes

- d87fa0268: feat!: experiments config renamed to flags

  - The `experiments` configuration is renamed to `flags`. The functionality is exactly the same.

  ```js
  flags: token: false;
  search: false;
  ```

  - The `self_path` property from the config file is being removed in favor of `config_file` full path.
  - Refactor `config` module, better types and utilities

- da1ee9c82: - Replace signature handler for legacy tokens by removing deprecated crypto.createDecipher by createCipheriv

  - Introduce environment variables for legacy tokens

  ### Code Improvements

  - Add debug library for improve developer experience

  ### Breaking change

  - The new signature invalidates all previous tokens generated by Verdaccio 4 or previous versions.
  - The secret key must have 32 characters long.

  ### New environment variables

  - `VERDACCIO_LEGACY_ALGORITHM`: Allows to define the specific algorithm for the token signature which by default is `aes-256-ctr`
  - `VERDACCIO_LEGACY_ENCRYPTION_KEY`: By default, the token stores in the database, but using this variable allows to get it from memory

### Minor Changes

- 26b494cbd: feat: add typescript project references settings

  Reading https://ebaytech.berlin/optimizing-multi-package-apps-with-typescript-project-references-d5c57a3b4440 I realized I can use project references to solve the issue to pre-compile modules on develop mode.

  It allows to navigate (IDE) trough the packages without need compile the packages.

  Add two `tsconfig`, one using the previous existing configuration that is able to produce declaration files (`tsconfig.build`) and a new one `tsconfig` which is enables [_projects references_](https://www.typescriptlang.org/docs/handbook/project-references.html).

### Patch Changes

- b57b43388: Enable prerelease mode with **changesets**
- 31af01641: ESLint Warnings Fixed

  Related to issue #1461

  - max-len: most of the sensible max-len errors are fixed
  - no-unused-vars: most of these types of errors are fixed by deleting not needed declarations
  - @typescript-eslint/no-unused-vars: same as above

- Updated dependencies [d87fa0268]
- Updated dependencies [da1ee9c82]
- Updated dependencies [26b494cbd]
- Updated dependencies [b57b43388]
- Updated dependencies [add778d55]
- Updated dependencies [31af01641]
  - @verdaccio/config@5.0.0-alpha.1
  - @verdaccio/logger@5.0.0-alpha.1
  - @verdaccio/node-api@5.0.0-alpha.1
