"use strict";

var _clipanion = require("clipanion");
var _core = require("@verdaccio/core");
var _info = require("./commands/info");
var _init = require("./commands/init");
var _version = require("./commands/version");
var _utils = require("./utils");
if (process.getuid && process.getuid() === 0) {
  _core.warningUtils.emit(_core.warningUtils.Codes.VERWAR001);
}
if (!(0, _utils.isVersionValid)(process.version)) {
  throw new Error(`Verdaccio requires at least Node.js v${_utils.MIN_NODE_VERSION} or higher and you have installed ${process.version}, 
    please upgrade your Node.js distribution`);
}
const [node, app, ...args] = process.argv;
const cli = new _clipanion.Cli({
  binaryLabel: `verdaccio`,
  binaryName: `${node} ${app}`,
  binaryVersion: require('../package.json').version
});
cli.register(_info.InfoCommand);
cli.register(_init.InitCommand);
cli.register(_version.VersionCommand);
cli.runExit(args, _clipanion.Cli.defaultContext);
process.on('uncaughtException', function (err) {
  console.error(
  // eslint-disable-next-line max-len
  `uncaught exception, please report (https://github.com/verdaccio/verdaccio/issues) this: \n${err.stack}`);
  process.exit(1);
});
//# sourceMappingURL=cli.js.map