"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.InfoCommand = void 0;
var _clipanion = require("clipanion");
var _envinfo = _interopRequireDefault(require("envinfo"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
class InfoCommand extends _clipanion.Command {
  static paths = [[`--info`], [`-i`]];
  async execute() {
    this.context.stdout.write('\nEnvironment Info:');
    const data = await _envinfo.default.run({
      System: ['OS', 'CPU'],
      Binaries: ['node', 'yarn', 'npm', 'pnpm'],
      Virtualization: ['Docker'],
      Browsers: ['Chrome', 'Edge', 'Firefox', 'Safari'],
      npmGlobalPackages: ['verdaccio']
    });
    this.context.stdout.write(data);
    process.exit(0);
  }
}
exports.InfoCommand = InfoCommand;
//# sourceMappingURL=info.js.map